/************************************************************************/
/* netbuffer.h - Network Buffer Header					*/
/************************************************************************/
/*
 *  (c)2003 Todd Shadburn
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#ifndef _NETBUFFER_H_
#define _NETBUFFER_H_

#include <netinfo/netinfo_portable.h>

#define	NET_BUFFER_SIZE		8192

typedef struct	_NetBuffer	NetBuffer;
struct _NetBuffer {
	u_int32_t	woffset;
	u_int32_t	roffset;
	unsigned char	buffer[NET_BUFFER_SIZE];
};

NETINFO_API int netbuffer_new (NetBuffer **nbp);
NETINFO_API int netbuffer_free (NetBuffer **nbp);
NETINFO_API void netbuffer_clear (NetBuffer *nb);
NETINFO_API int netbuffer_write (NetBuffer *nb, void *data, u_int32_t datalen);
NETINFO_API int netbuffer_read (NetBuffer *nb, void *data, u_int32_t datalen);
NETINFO_API int netbuffer_bytes_in_buffer (NetBuffer *nb, u_int32_t *bytes);
NETINFO_API void netbuffer_dump (NetBuffer *nb);

#endif


