/************************************************************************/
/* rpc.c - Netinfo RPC Source						*/
/************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>

#include <netinfo/netinfo_portable.h>
#include <netinfo/netinfo.h>
#include <netinfo/rpc.h>


NETINFO_API void netinfo_rpcheader_hton(NetinfoRpcHeader *rpcheader)
{
	if (rpcheader == NULL)
		return;
	rpcheader->callid = htonl(rpcheader->callid);
	rpcheader->requestid = htonl(rpcheader->requestid);
	rpcheader->returncode = htonl(rpcheader->returncode);
	rpcheader->reserved1 = htonl(rpcheader->reserved1);
	return;
}


NETINFO_API void netinfo_rpcheader_ntoh(NetinfoRpcHeader *rpcheader)
{
	if (rpcheader == NULL)
		return;
	rpcheader->callid = ntohl(rpcheader->callid);
	rpcheader->requestid = ntohl(rpcheader->requestid);
	rpcheader->returncode = ntohl(rpcheader->returncode);
	rpcheader->reserved1 = ntohl(rpcheader->reserved1);
	return;
}


NETINFO_API void netinfo_rpcfileopen_hton(NetinfoRpcFileOpen *rpcfileopen)
{
	if (rpcfileopen == NULL)
		return;
	rpcfileopen->fileid = htonl(rpcfileopen->fileid);
	rpcfileopen->access = htonl(rpcfileopen->access);
	rpcfileopen->reserved1 = htonl(rpcfileopen->reserved1);
	return;
}


NETINFO_API void netinfo_rpcfileopen_ntoh(NetinfoRpcFileOpen *rpcfileopen)
{
	if (rpcfileopen == NULL)
		return;
	rpcfileopen->fileid = ntohl(rpcfileopen->fileid);
	rpcfileopen->access = ntohl(rpcfileopen->access);
	rpcfileopen->reserved1 = ntohl(rpcfileopen->reserved1);
	return;
}


NETINFO_API void netinfo_rpcfileclose_hton(NetinfoRpcFileClose *rpcfileclose)
{
	if (rpcfileclose == NULL)
		return;
	rpcfileclose->fileid = htonl(rpcfileclose->fileid);
	rpcfileclose->reserved1 = htonl(rpcfileclose->reserved1);
	return;
}


NETINFO_API void netinfo_rpcfileclose_ntoh(NetinfoRpcFileClose *rpcfileclose)
{
	if (rpcfileclose == NULL)
		return;
	rpcfileclose->fileid = ntohl(rpcfileclose->fileid);
	rpcfileclose->reserved1 = ntohl(rpcfileclose->reserved1);
	return;
}


NETINFO_API void netinfo_rpcfiledata_hton(NetinfoRpcFileData *rpcfiledata)
{
	if (rpcfiledata == NULL)
		return;
	rpcfiledata->fileid = htonl(rpcfiledata->fileid);
	rpcfiledata->direction = htonl(rpcfiledata->direction);
	rpcfiledata->offset = htonl(rpcfiledata->offset);
	rpcfiledata->length = htonl(rpcfiledata->length);
	return;
}


NETINFO_API void netinfo_rpcfiledata_ntoh(NetinfoRpcFileData *rpcfiledata)
{
	if (rpcfiledata == NULL)
		return;
	rpcfiledata->fileid = ntohl(rpcfiledata->fileid);
	rpcfiledata->direction = ntohl(rpcfiledata->direction);
	rpcfiledata->offset = ntohl(rpcfiledata->offset);
	rpcfiledata->length = ntohl(rpcfiledata->length);
	return;
}


NETINFO_API void netinfo_rpclisthead_hton(NetinfoRpcListHead *rpclisthead)
{
	if (rpclisthead == NULL)
		return;
	rpclisthead->itemsize = htonl(rpclisthead->itemsize);
	rpclisthead->itemcount = htonl(rpclisthead->itemcount);
	return;
}


NETINFO_API void netinfo_rpclisthead_ntoh(NetinfoRpcListHead *rpclisthead)
{
	if (rpclisthead == NULL)
		return;
	rpclisthead->itemsize = ntohl(rpclisthead->itemsize);
	rpclisthead->itemcount = ntohl(rpclisthead->itemcount);
	return;
}




