/************************************************************************/
/* average.h - averaging structure and API				*/
/************************************************************************/
/*
 *  (c)2005 Todd Shadburn
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/
/************************************************************************/



#ifndef _AVERAGE_H_
#define _AVERAGE_H_


#define AVERAGE_TYPE_INTEGER32          1
#define AVERAGE_TYPE_INTEGER64          2
#define AVERAGE_TYPE_FLOAT              3
#define AVERAGE_TYPE_DOUBLE             4

typedef union   _AverageValue   AverageValue;
union _AverageValue {
        int32_t         i32;
        int64_t         i64;
        float           f;
        double          d;
};

typedef struct  _Average        Average;
struct _Average {
        int             type;
        int             size;
        int             index;
        AverageValue    *average;
};


Average *average_new (int avgtype, int avgcount);
int average_free (Average *a);
int average_push_value (Average *a, void *valuep);
int average_get_average (Average *a, void *valuep);

#endif

