
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>


#include <netinfo/netinfo.h>
#include <netinfo/nmodule.h>


#define	MODULE_NAME		"test"
#define	MODULE_VERSION		"0.1.0"

ModuleInfo	*moduleinfo;

int netinfo_module_init (ModuleInfo *mi)
{
	if (mi == NULL)
		return NETINFO_RC_INVALIDARG;
	moduleinfo = mi;
	moduleinfo->name = MODULE_NAME;
	return NETINFO_RC_SUCCESS;
}

int netinfo_module_close (ModuleInfo *mi)
{
	if (mi == NULL)
		return NETINFO_RC_INVALIDARG;
	return NETINFO_RC_SUCCESS;
}

int netinfo_module_execute_method (char *method,
					NetinfoHeader *nh,
					char **responsedata,
					unsigned long *responsedatalen)
{
	int rc;
	int argdatalen;
	char argdata[NETINFO_HEADER_ARGDATA_SIZE];
	char *rd = NULL;
	if (method == NULL ||
			nh == NULL ||
			responsedata == NULL ||
			responsedatalen == NULL)
		return NETINFO_RC_INVALIDARG;
	*responsedata = NULL;
	*responsedatalen = 0;
	argdatalen = NETINFO_HEADER_ARGDATA_SIZE;
	rc = netinfo_header_get_argdata (nh,
				argdata,
				&argdatalen);
	if (!strcmp (method, "echo")) {
		rd = calloc (1, argdatalen);
		memcpy (rd, argdata, argdatalen);
		*responsedata = rd;
		*responsedatalen = argdatalen;
		rc = netinfo_header_set_status (nh, NETINFO_STATUS_RESPONSE);
		rc = netinfo_header_set_flags (nh, 0);
		rc = netinfo_header_set_rc (nh, NETINFO_RC_SUCCESS);
	} else {
		return NETINFO_RC_INVALIDARG;
	}
	return NETINFO_RC_SUCCESS;
}


