/************************************************************************/
/* stack.c - A stack implementation 		 			*/
/************************************************************************/
/*
 * (c) 2002-2003 Todd Shadburn
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
/************************************************************************/

#include <stdlib.h>

#include "stack.h"

/* Hidden from users */
struct sstackitem_s{
	void *data;
	sstackitem_t *next;
	};

struct sstack_s{
	sstackitem_t *head;
	int items;
	};


/************************************************************************/
/* Function Declarations						*/
/************************************************************************/
sstack_t *sstack_new(void){
	sstack_t *s;
	s = (sstack_t *)calloc(1, sizeof(sstack_t));
	return s;
	}


int sstack_free(sstack_t *stack) {
	sstackitem_t *si;
	sstackitem_t *si2;
	if (stack == NULL)
		return -1;
	si = stack->head;
	while (si) {
		si2 = si->next;
		free(si);
		si = si2;
		}
	free(stack);
	return 0;
	}


int sstack_items(sstack_t *stack) {
	if (stack == NULL)
		return -1;
	return stack->items;
	}


int sstack_push(sstack_t *stack, void *data) {
	sstackitem_t *si;
	if (stack == NULL || data == NULL)
		return -1;
	si = (sstackitem_t *)calloc(1, sizeof(sstackitem_t));
	if (si == NULL)
		return -1;
	si->data = data;
	si->next = stack->head;
	stack->head = si;
	stack->items++;
	return 0;
	}


void *sstack_pop(sstack_t *stack) {
	void *data;
	sstackitem_t *si;
	if (stack == NULL)
		return NULL;
	if (stack->head == NULL)
		return NULL;
	si = stack->head;
	data = si->data;
	stack->head = si->next;
	stack->items--;
	free(si);
	return data;
	}	


